/* Problem URL: https://codeforces.com/contest/946/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;

    vvi hours(n);

    repv(i, hours) {
        string fds;
        cin >> fds;

        rep(j, m) {
            if (fds[j] == '1') {
                i.push_back(j);
            }
        }
    }

    vvi bestbyk(n, vi(k + 1));

    rep(i, n) {
        if (hours[i].empty()) {
            continue;
        }

        bestbyk[i][0] = (hours[i].back() - hours[i].front() + 1);

        for (int j = 1; j <= k && j < hours[i].size(); j++) {
            bestbyk[i][j] = INT32_MAX >> 1;
            rep(l, j + 1) {
                rmin(bestbyk[i][j], hours[i][hours[i].size() - (j - l + 1)] - hours[i][l] + 1);
            }
        }
    }

    int oo = INT32_MAX >> 1;

    vvi dp(n + 1, vi(k + 1, oo));
    fill(all(dp[0]), 0);

    nrep(i, 1, n + 1) {
        rep(j, k + 1) {
            rep(l, j + 1) {
                rmin(dp[i][j], bestbyk[i - 1][l] + dp[i - 1][j - l]);
            }
        }
    }

    cout << dp.back().back() << '\n';
}
